package cn.wise.sc.cement.business.util;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.formula.functions.T;
import org.apache.poi.ss.usermodel.*;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * excel工具类
 * 
 * @author zhutianwei
 *
 */
public class CheckCountUtil {

	//倍数
	public final static BigDecimal param10 = new BigDecimal(10.00);
	public final static BigDecimal param100 = new BigDecimal(100.00);
	public final static BigDecimal param1000 = new BigDecimal(1000.00);


	//object 转成  BigDecimal
	public static BigDecimal getBigDecimal(Object value ) {
		BigDecimal ret = null;
		if( value != null ) {
			if( value instanceof BigDecimal ) {
				ret = (BigDecimal) value;
			} else if( value instanceof String ) {
				ret = new BigDecimal( (String) value );
			} else if( value instanceof BigInteger) {
				ret = new BigDecimal( (BigInteger) value );
			} else if( value instanceof Number ) {
				ret = new BigDecimal( ((Number)value).doubleValue() );
			} else {
				throw new ClassCastException("Not possible to coerce ["+value+"] from class "+value.getClass()+" into a BigDecimal.");
			}
		}
		return ret;
	}

	/**
	 * 检测项名称
	 * @param name
	 * @return
	 */
	//加 add 减 subtract  乘 multiply  除 divide
	public static BigDecimal checkCount(String name, Map<String, Object> resultMap) {
		BigDecimal endResult = null;
		if(name.equals("L.O.I")){
			//样重m1—保留4位⼩数
			BigDecimal m1 = getBigDecimal(resultMap.get("样重m1")).setScale(4,BigDecimal.ROUND_HALF_UP);
			//空堝重m2—保留4位⼩数
			BigDecimal m2 = getBigDecimal(resultMap.get("空堝重m2")).setScale(4,BigDecimal.ROUND_HALF_UP);
			//烧后重m3—保留4位⼩数
			BigDecimal m3 = getBigDecimal(resultMap.get("烧后重m3")).setScale(4,BigDecimal.ROUND_HALF_UP);
			//计算的核心公式结果
			BigDecimal countResult = (m1.add(m2).subtract(m3)).divide(m1);
			BigDecimal result1 = countResult.multiply(param100.multiply(param100));
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.multiply(param100).setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.multiply(param100).subtract(new BigDecimal(0.0000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("SiO2")){
			//毫升数
			BigDecimal VSiO2 = getBigDecimal(resultMap.get("VSiO2"));
			//滴定度
			BigDecimal TSiO2 = getBigDecimal(resultMap.get("TSiO2"));
			//样m
			BigDecimal m = getBigDecimal(resultMap.get("样重m"));
			//计算的核心公式结果
			BigDecimal countResult = VSiO2.multiply(TSiO2).divide(m);
			BigDecimal result1 = countResult.multiply(param100);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.0000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("Al2O3+TiO2")){
			BigDecimal TAl2O3 = getBigDecimal(resultMap.get("TAl2O3"));
			BigDecimal VAl2O3 = getBigDecimal(resultMap.get("VAl2O3"));
			BigDecimal K = getBigDecimal(resultMap.get("K"));
			BigDecimal VCuSO4_I = getBigDecimal(resultMap.get("VCuSO4（I）"));
			BigDecimal m = getBigDecimal(resultMap.get("样重m"));
			//计算的核心公式结果
			BigDecimal countResult = TAl2O3.multiply(VAl2O3.subtract(K.multiply(VCuSO4_I))).divide(m);
			BigDecimal result1 = countResult.multiply(param100);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.0000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("Al2O3")){
			BigDecimal TAl2O3 = getBigDecimal(resultMap.get("TAl2O3"));
			BigDecimal VAl2O3 = getBigDecimal(resultMap.get("VAl2O3"));
			BigDecimal K = getBigDecimal(resultMap.get("K"));
			BigDecimal VCuSO4_I = getBigDecimal(resultMap.get("VCuSO4（I）"));
			BigDecimal m = getBigDecimal(resultMap.get("样重m"));
			BigDecimal VCuSO4_II = getBigDecimal(resultMap.get("VCuSO4（II）"));
			//计算的核心公式结果
			BigDecimal countResult = TAl2O3.multiply(VAl2O3.subtract(K.multiply(VCuSO4_I.add(VCuSO4_II)))).divide(m);
			BigDecimal result1 = countResult.multiply(param100);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.0000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("Fe2O3")){
			BigDecimal TFe2O3  = getBigDecimal(resultMap.get("TFe2O3"));
			BigDecimal VF2O3  = getBigDecimal(resultMap.get("VF2O3"));
			BigDecimal m = getBigDecimal(resultMap.get("样重m"));
			//计算的核心公式结果
			BigDecimal countResult = TFe2O3.multiply(VF2O3).divide(m);
			BigDecimal result1 = countResult.multiply(param100);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.0000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("Cl")){
			BigDecimal T  = getBigDecimal(resultMap.get("T"));
			BigDecimal V2  = getBigDecimal(resultMap.get("V2 "));
			BigDecimal V1  = getBigDecimal(resultMap.get("V1 "));
			BigDecimal mCl = getBigDecimal(resultMap.get("样重Cl"));
			//计算的核心公式结果
			BigDecimal countResult = T.multiply(V2.subtract(V1)).divide(mCl).divide(param10);
			BigDecimal result1 = countResult.multiply(param1000);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(3,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.00000000001)).setScale(3,BigDecimal.ROUND_HALF_UP);
			}
		}else if(name.equals("CaO")){
			BigDecimal TCaO  = getBigDecimal(resultMap.get("TCaO"));
			BigDecimal VCaO  = getBigDecimal(resultMap.get("VCaO"));
			BigDecimal m = getBigDecimal(resultMap.get("样重m"));
			//计算的核心公式结果
			BigDecimal countResult = TCaO.multiply(VCaO).divide(m);
			BigDecimal result1 = countResult.multiply(param100);
			int resultInt1  = result1.setScale( 0, BigDecimal.ROUND_DOWN ).intValue();
			if((resultInt1&1) == 1){  //如果结果为奇数
				endResult =  countResult.setScale(2,BigDecimal.ROUND_HALF_UP);
			}else{
				endResult = countResult.subtract(new BigDecimal(0.00000000001)).setScale(2,BigDecimal.ROUND_HALF_UP);
			}
		}
		return endResult;
	}

	/**
	 *  求合量   L.O.I+SiO2+Al2O3+Fe2O3+CaO+MgO+TiO2+K2O+Na2O+MnO+SO3
	 * @param countMap
	 * @return
	 */
	public static BigDecimal countHL(Map<String, Object> countMap) {
		List<String> list = new ArrayList<>();
		list.add(countMap.get("L.O.I").toString());
		list.add(countMap.get("SiO2").toString());
		list.add(countMap.get("Al2O3").toString());
		list.add(countMap.get("Fe2O3").toString());
		list.add(countMap.get("CaO").toString());
		list.add(countMap.get("MgO").toString());
		list.add(countMap.get("TiO2").toString());
		list.add(countMap.get("K2O").toString());
		list.add(countMap.get("Na2O").toString());
		list.add(countMap.get("MnO").toString());
		list.add(countMap.get("SO3").toString());
		BigDecimal count=new BigDecimal(0);
		for(String s:list) {
			count = count.add(new BigDecimal(s));
		}
		return count;
	}

	/**
	 * 求KH (CaO - 1.65*{Al2O3+TiO2} * Fe2O3) / 2.8 / SiO2
	 * @param countMap
	 * @return
	 */
	public static BigDecimal countKH(Map<String, Object> countMap) {
		BigDecimal CaO = getBigDecimal(countMap.get("Cao"));
		BigDecimal Al2O3_TiO2= getBigDecimal(countMap.get("Al2O3+TiO2"));
		BigDecimal Fe2O3 = getBigDecimal(countMap.get("Fe2O3"));
		BigDecimal SiO2 = getBigDecimal(countMap.get("SiO2"));
		BigDecimal KH =
		CaO.subtract(new BigDecimal(1.65).multiply(Al2O3_TiO2).multiply(Fe2O3)).divide(new BigDecimal(2.8)).divide(SiO2);
		return KH;
	}










}


	//计算多个值的和
	/*List<String> list=new ArrayList<>();
		list.add("123.0");
				list.add("12.0");
				list.add("3.0");
				BigDecimal count=new BigDecimal(0);
				for(String s:list) {
				count = count.add(new BigDecimal(s));
				}
				System.out.println(count);


*/










